/*
  $Header: d:\\Personal\\cvs/aj/src/wrong/WrongBuffering1.java,v 1.2 2002/02/01 03:56:41 ikk Exp $ $Name:  $

  $Log: WrongBuffering1.java,v $
  Revision 1.2  2002/02/01 03:56:41  ikk
  Name changes.

  Revision 1.1  2002/02/01 02:25:16  ikk
  Initial.

*/

package wrong;

import java.io.*;

public aspect WrongBuffering1
{
    public static final String cvs="$Id: WrongBuffering1.java,v 1.2 2002/02/01 03:56:41 ikk Exp $";

    private static final int BUFF_SIZE=256;

    byte[] buff = new byte[BUFF_SIZE];
    int counter = 0;

    pointcut writeBytes(byte[] bytes):
    call(void FileOutputStream.write(byte[]))
    && args(bytes)
    && !within(WrongBuffering1);

    void around(byte[] bytes) throws IOException: writeBytes(bytes)
    {
        FileOutputStream out =
          (FileOutputStream)thisJoinPoint.getTarget();
        if(counter + bytes.length > BUFF_SIZE)
        {
            out.write(buff, 0, counter);
            out.write(bytes);
            
            counter=0;
        }
        else
        {
            System.arraycopy(bytes, 0, buff, counter, bytes.length);
            counter += bytes.length;
        }
    }
}
