/*
  $Header: d:\\Personal\\cvs/aj/src/language/AdviceAfterReturning.java,v 1.3 2002/03/24 02:13:02 ikk Exp $ $Name:  $

  $Log: AdviceAfterReturning.java,v $
  Revision 1.3  2002/03/24 02:13:02  ikk
  Added advice numbers to the output.

  Revision 1.2  2002/03/23 16:21:16  ikk
  Formatted ouput, added class names.

  Revision 1.1  2002/03/23 00:55:27  ikk
  Initial.

*/

public aspect AdviceAfterReturning
{
    public static final String cvs="$Id: AdviceAfterReturning.java,v 1.3 2002/03/24 02:13:02 ikk Exp $";

    // 1
    after() returning(Object o) : call(* AdviceMain.*Str(..))
    {
        System.out.println("#1: "+thisJoinPoint+" Returning Object: "+
                           AdviceMain.className(o)+" - "+o);
    }

    // 2
    after() returning(int o) : call(* AdviceMain.*Str(..))
    {
        System.out.println("#2: "+thisJoinPoint+" Returning int: "+
                           "int"+" - "+o);
    }

    // 3
    after() returning(String o) : call(* AdviceMain.*Str(..))
    {
        System.out.println("#3: "+thisJoinPoint+" Returning String: "+
                           AdviceMain.className(o)+" - "+o);
    }

    // 4
    after() returning : call(* AdviceMain.*Str(..))
    {
        System.out.println("#4: "+thisJoinPoint+" Returning anything.");
    }
}


