/*
  $Header: d:\\Personal\\cvs/aj/src/language/AdviceAfterThrowing.java,v 1.3 2002/03/24 03:41:04 ikk Exp $ $Name:  $

  $Log: AdviceAfterThrowing.java,v $
  Revision 1.3  2002/03/24 03:41:04  ikk
  Added numbers to the advice output.

  Revision 1.2  2002/03/23 16:56:38  ikk
  Added more detailed output. Numbered advices.

  Revision 1.1  2002/03/23 00:55:27  ikk
  Initial.

*/

public aspect AdviceAfterThrowing
{
    public static final String cvs="$Id: AdviceAfterThrowing.java,v 1.3 2002/03/24 03:41:04 ikk Exp $";

    // 1
    after() throwing(Exception o) : call(* AdviceMain.*Str(..))
    {
        System.out.println("#1: "+thisJoinPoint+" Throwing Exception: "+
                           AdviceMain.className(o)+" - "+o);
    }

    // 2
    after() throwing(RuntimeException o) : call(* AdviceMain.*Str(..))
    {
        System.out.println("#2: "+thisJoinPoint+" Throwing RuntimeException: "+
                           AdviceMain.className(o)+" - "+o);
    }

    // 3
    after() throwing : call(* AdviceMain.*Str(..))
    {
        System.out.println("#3: "+thisJoinPoint+" Throwing anything.");
    }

}


