/*
  $Header: d:\\Personal\\cvs/aj/src/language/AdvicePrecedence.java,v 1.2 2002/03/26 03:31:25 ikk Exp $ $Name:  $

  $Log: AdvicePrecedence.java,v $
  Revision 1.2  2002/03/26 03:31:25  ikk
  Added commented out modifications.

  Revision 1.1  2002/03/25 22:40:02  ikk
  Initial.

*/

public aspect AdviceAfterReturning
{
    public static final String cvs="$Id: AdvicePrecedence.java,v 1.2 2002/03/26 03:31:25 ikk Exp $";

    pointcut p(): call(* AdviceMain.intStr(..));

    // after 1
    after() : p()
    {
        System.out.println("After  1");
    }

    // after 2
    after() returning(int o) : p()
    {
        System.out.println("After  2");
    }

    // before 1
    before() : p()
    {
        System.out.println("Before 1");
    }

    // before 2
    before() throws Exception : p()
    {
//        throw new Exception("Before 2 exception.");
        System.out.println("Before 2");
    }

    // around 1
    int around() : p()
    {
        System.out.println("Around 1 - before proceed");
        int result = proceed();
        System.out.println("Around 1 - after  proceed");
        return result;
    }

    // around 2
    int around() : p()
    {
//        System.out.println("Around 2 - no proceed");
//        return 5;
        System.out.println("Around 2 - before proceed");
        int result = proceed();
        System.out.println("Around 2 - after  proceed");
        return result;
    }
}


