/*
  $Header: d:\\Personal\\cvs/aj/src/aspects/ConnectionChecking.java,v 1.2 2002/02/07 05:57:18 ikk Exp $ $Name:  $

  $Log: ConnectionChecking.java,v $
  Revision 1.2  2002/02/07 05:57:18  ikk
  Removed attempt counting.

  Revision 1.1  2002/02/07 04:24:10  ikk
  Initial.

*/

package aspects;

import java.sql.*;
import java.util.*;

public aspect ConnectionChecking dominates Pooling
{
    public static final String cvs="$Id: ConnectionChecking.java,v 1.2 2002/02/07 05:57:18 ikk Exp $";

    Connection around() throws SQLException: call(static Connection DriverManager.getConnection(..))
    {
        Connection conn;
        do
        {
            conn = proceed();
        }
        while(bad(conn));

        return conn;
    }

    private boolean bad(Connection conn)
    {
        try
        {
            Statement stmt = conn.createStatement();
            ResultSet rs = stmt.executeQuery("SELECT 2+2");

            if(rs.next())
            {
                rs.getString(1);
            }
            rs.close();
            stmt.close();
        }
        catch(SQLException e)
        {
            return true;
        }
        return false;
    }
}


