/*
  $Header: d:\\Personal\\cvs/aj/src/language/ParamAspect.java,v 1.2 2002/03/17 21:47:39 ikk Exp $ $Name:  $

  $Log: ParamAspect.java,v $
  Revision 1.2  2002/03/17 21:47:39  ikk
  Added wild cards in call() and execution() declarations.

  Revision 1.1  2002/03/17 20:46:47  ikk
  Initial.

*/

public aspect ParamAspect
{
    public static final String cvs="$Id: ParamAspect.java,v 1.2 2002/03/17 21:47:39 ikk Exp $";

    pointcut q(ParamMain obj) : execution(* *.exec(int, String)) && target(obj);
    before(ParamMain obj) : q(obj)
    {
        System.out.println("q(): "+obj.getClass().getName());
    }

    pointcut r(int x, String y) : call(* *.exec(int, String)) && args(x, y);
    before(int x, String y) : r(x, y)
    {
        System.out.println("r(): "+x+" and "+y);
    }
}
