/*
  $Header: d:\\Personal\\cvs/aj/src/language/AdviceMain.java,v 1.4 2002/03/24 02:03:34 ikk Exp $ $Name:  $

  $Log: AdviceMain.java,v $
  Revision 1.4  2002/03/24 02:03:34  ikk
  Added output inside methods.

  Revision 1.3  2002/03/23 22:53:10  ikk
  Added exception to voidStr() method.

  Revision 1.2  2002/03/23 16:57:43  ikk
  Added className() method.

  Revision 1.1  2002/03/23 00:55:27  ikk
  Initial.

*/

public class AdviceMain
{
    public static final String cvs="$Id: AdviceMain.java,v 1.4 2002/03/24 02:03:34 ikk Exp $";

    static public String className(Object o)
    {
        String name = "none";
        if(null != o)
        {
            name = o.getClass().getName();
        }
        return name;
    }

    public int intStr(String s) throws Exception
    {
        System.out.println("Inside intStr() method.");

        int b;
        try
        {
            b = Integer.parseInt(s);
        }
        catch(NumberFormatException e)
        {
            throw new Exception("Bad format.");
        }
        return b;
    }

    public String strStr(String s)
    {
        System.out.println("Inside strStr() method.");

        int b = Integer.parseInt(s);
        return Integer.toString(b);
    }

    public void voidStr(String s) throws IllegalAccessException
    {
        System.out.println("Inside voidStr() method.");

        int b;
        try
        {
            b = Integer.parseInt(s);
        }
        catch(NumberFormatException e)
        {
            throw new IllegalAccessException("Bad format.");
        }
        
        return;
    }

    public static void main(String args[])
    {
        AdviceMain am = new AdviceMain();
        try
        {
            am.intStr(args[0]);
        }
        catch(Throwable e)
        {
            System.out.println("Got :"+e);
        }

        try
        {
            am.strStr(args[0]);
        }
        catch(Throwable e)
        {
            System.out.println("Got :"+e);
        }

        try
        {
            am.voidStr(args[0]);
        }
        catch(Throwable e)
        {
            System.out.println("Got :"+e);
        }
    }
}
